[arch-commits] Commit in python2/repos (6 files)

Felix Yan fyan at archlinux.org
Thu Mar 31 06:43:46 UTC 2016


    Date: Thursday, March 31, 2016 @ 08:43:46
  Author: fyan
Revision: 263482

archrelease: copy trunk to extra-i686, extra-x86_64

Added:
  python2/repos/extra-i686/PKGBUILD
    (from rev 263481, python2/trunk/PKGBUILD)
  python2/repos/extra-i686/descr_ref.patch
    (from rev 263481, python2/trunk/descr_ref.patch)
  python2/repos/extra-x86_64/PKGBUILD
    (from rev 263481, python2/trunk/PKGBUILD)
  python2/repos/extra-x86_64/descr_ref.patch
    (from rev 263481, python2/trunk/descr_ref.patch)
Deleted:
  python2/repos/extra-i686/PKGBUILD
  python2/repos/extra-x86_64/PKGBUILD

------------------------------+
 /PKGBUILD                    |  254 +++++++++++++++++++++++++++++++++++++++++
 extra-i686/PKGBUILD          |  121 -------------------
 extra-i686/descr_ref.patch   |   58 +++++++++
 extra-x86_64/PKGBUILD        |  121 -------------------
 extra-x86_64/descr_ref.patch |   58 +++++++++
 5 files changed, 370 insertions(+), 242 deletions(-)

Deleted: extra-i686/PKGBUILD
===================================================================
--- extra-i686/PKGBUILD	2016-03-31 06:43:03 UTC (rev 263481)
+++ extra-i686/PKGBUILD	2016-03-31 06:43:46 UTC (rev 263482)
@@ -1,121 +0,0 @@
-# $Id$
-# Maintainer: Felix Yan <felixonmars at archlinux.org>
-# Contributor: Stéphane Gaudreault <stephane at archlinux.org>
-# Contributor: Allan McRae <allan at archlinux.org>
-# Contributor: Jason Chu <jason at archlinux.org>
-
-pkgname=python2
-pkgver=2.7.11
-pkgrel=2
-_pybasever=2.7
-pkgdesc="A high-level scripting language"
-arch=('i686' 'x86_64')
-license=('PSF')
-url="http://www.python.org/"
-depends=('bzip2' 'gdbm' 'openssl' 'zlib' 'expat' 'sqlite' 'libffi')
-makedepends=('tk' 'bluez-libs' 'hardening-wrapper')
-checkdepends=('gdb' 'file')
-optdepends=('tk: for IDLE'
-            'python2-setuptools'
-            'python2-pip')
-conflicts=('python<3')
-source=(http://www.python.org/ftp/python/${pkgver%rc?}/Python-${pkgver}.tar.xz)
-sha1sums=('c3b8bbe3f084c4d4ea13ffb03d75a5e22f9756ff')
-
-prepare() {
-  cd Python-${pkgver}
-
-  # Temporary workaround for FS#22322
-  # See http://bugs.python.org/issue10835 for upstream report
-  sed -i "/progname =/s/python/python${_pybasever}/" Python/pythonrun.c
-
-  # Enable built-in SQLite module to load extensions (fix FS#22122)
-  sed -i "/SQLITE_OMIT_LOAD_EXTENSION/d" setup.py
-
-  # FS#23997
-  sed -i -e "s|^#.* /usr/local/bin/python|#!/usr/bin/python2|" Lib/cgi.py
-
-  sed -i "s/python2.3/python2/g" Lib/distutils/tests/test_build_scripts.py \
-    Lib/distutils/tests/test_install_scripts.py
-
-  # TODO: Still not passed
-  # Silent test_gdb failures on 'no symbol table loaded'.
-  #sed -i '/ignore_patterns = (/a "No symbol table is loaded.  Use the \\"file\\" command.",' \
-  #  Lib/test/test_gdb.py
-
-  # Ensure that we are using the system copy of various libraries (expat, zlib and libffi),
-  # rather than copies shipped in the tarball
-  rm -r Modules/expat
-  rm -r Modules/zlib
-  rm -r Modules/_ctypes/{darwin,libffi}*
-
-  # clean up #!s
-  find . -name '*.py' | \
-    xargs sed -i "s|#[ ]*![ ]*/usr/bin/env python$|#!/usr/bin/env python2|"
-
-  # Workaround asdl_c.py/makeopcodetargets.py errors after we touched the shebangs
-  touch Include/Python-ast.h Python/Python-ast.c Python/opcode_targets.h
-}
-
-build() {
-  cd "${srcdir}/Python-${pkgver}"
-
-  export OPT="${CFLAGS}"
-  ./configure --prefix=/usr \
-              --enable-shared \
-              --with-threads \
-              --enable-ipv6 \
-              --enable-unicode=ucs4 \
-              --with-system-expat \
-              --with-system-ffi \
-              --with-dbmliborder=gdbm:ndbm \
-              --without-ensurepip
-
-  make
-}
-
-check() {
-  # As of 2.7.11, 2 tests failed:
-  # test_doctest test_gdb
-  # Besides, test_thread disabled as it will stuck
-  
-  # $SHELL was set to avoid a test failure in test_gdb (it still fails due to other reasons, though)
-
-  cd Python-${pkgver}
-  SHELL=/bin/sh LD_LIBRARY_PATH="${srcdir}/Python-${pkgver}":${LD_LIBRARY_PATH} \
-    "${srcdir}/Python-${pkgver}/python" -m test.regrtest -v -uall -x test_thread || warning "Tests failed"
-}
-
-package() {
-  cd Python-${pkgver}
-  make DESTDIR="${pkgdir}" altinstall maninstall
-
-  rm "${pkgdir}"/usr/share/man/man1/python.1
-
-  ln -sf python${_pybasever}        "${pkgdir}"/usr/bin/python2
-  ln -sf python${_pybasever}-config "${pkgdir}"/usr/bin/python2-config
-  ln -sf python${_pybasever}.1      "${pkgdir}"/usr/share/man/man1/python2.1
-
-  # FS#33954
-  ln -sf python-${_pybasever}.pc    "${pkgdir}"/usr/lib/pkgconfig/python2.pc
-
-  ln -sf ../../libpython${_pybasever}.so "${pkgdir}"/usr/lib/python${_pybasever}/config/libpython${_pybasever}.so
-
-  mv "${pkgdir}"/usr/bin/smtpd.py "${pkgdir}"/usr/lib/python${_pybasever}/
-
-  # some useful "stuff"
-  install -dm755 "${pkgdir}"/usr/lib/python${_pybasever}/Tools/{i18n,scripts}
-  install -m755 Tools/i18n/{msgfmt,pygettext}.py "${pkgdir}"/usr/lib/python${_pybasever}/Tools/i18n/
-  install -m755 Tools/scripts/{README,*py} "${pkgdir}"/usr/lib/python${_pybasever}/Tools/scripts/
-
-  # fix conflicts with python
-  mv "${pkgdir}"/usr/bin/idle{,2}
-  mv "${pkgdir}"/usr/bin/pydoc{,2}
-  mv "${pkgdir}"/usr/bin/2to3{,-2.7}
-
-  # clean-up reference to build directory
-  sed -i "s#${srcdir}/Python-${pkgver}:##" "${pkgdir}"/usr/lib/python${_pybasever}/config/Makefile
-
-  # license
-  install -Dm644 LICENSE "${pkgdir}"/usr/share/licenses/${pkgname}/LICENSE
-}

Copied: python2/repos/extra-i686/PKGBUILD (from rev 263481, python2/trunk/PKGBUILD)
===================================================================
--- extra-i686/PKGBUILD	                        (rev 0)
+++ extra-i686/PKGBUILD	2016-03-31 06:43:46 UTC (rev 263482)
@@ -0,0 +1,127 @@
+# $Id$
+# Maintainer: Felix Yan <felixonmars at archlinux.org>
+# Contributor: Stéphane Gaudreault <stephane at archlinux.org>
+# Contributor: Allan McRae <allan at archlinux.org>
+# Contributor: Jason Chu <jason at archlinux.org>
+
+pkgname=python2
+pkgver=2.7.11
+pkgrel=3
+_pybasever=2.7
+pkgdesc="A high-level scripting language"
+arch=('i686' 'x86_64')
+license=('PSF')
+url="http://www.python.org/"
+depends=('bzip2' 'gdbm' 'openssl' 'zlib' 'expat' 'sqlite' 'libffi')
+makedepends=('tk' 'bluez-libs' 'hardening-wrapper')
+checkdepends=('gdb' 'file')
+optdepends=('tk: for IDLE'
+            'python2-setuptools'
+            'python2-pip')
+conflicts=('python<3')
+source=(http://www.python.org/ftp/python/${pkgver%rc?}/Python-${pkgver}.tar.xz
+        descr_ref.patch)
+sha1sums=('c3b8bbe3f084c4d4ea13ffb03d75a5e22f9756ff'
+          '8cc6ac63e909063eb16bbdabc0f0eac7d24ff0c1')
+
+prepare() {
+  cd Python-${pkgver}
+
+  # Temporary workaround for FS#22322
+  # See http://bugs.python.org/issue10835 for upstream report
+  sed -i "/progname =/s/python/python${_pybasever}/" Python/pythonrun.c
+
+  # Enable built-in SQLite module to load extensions (fix FS#22122)
+  sed -i "/SQLITE_OMIT_LOAD_EXTENSION/d" setup.py
+
+  # FS#23997
+  sed -i -e "s|^#.* /usr/local/bin/python|#!/usr/bin/python2|" Lib/cgi.py
+
+  sed -i "s/python2.3/python2/g" Lib/distutils/tests/test_build_scripts.py \
+    Lib/distutils/tests/test_install_scripts.py
+
+  # TODO: Still not passed
+  # Silent test_gdb failures on 'no symbol table loaded'.
+  #sed -i '/ignore_patterns = (/a "No symbol table is loaded.  Use the \\"file\\" command.",' \
+  #  Lib/test/test_gdb.py
+
+  # Ensure that we are using the system copy of various libraries (expat, zlib and libffi),
+  # rather than copies shipped in the tarball
+  rm -r Modules/expat
+  rm -r Modules/zlib
+  rm -r Modules/_ctypes/{darwin,libffi}*
+
+  # clean up #!s
+  find . -name '*.py' | \
+    xargs sed -i "s|#[ ]*![ ]*/usr/bin/env python$|#!/usr/bin/env python2|"
+
+  # Workaround asdl_c.py/makeopcodetargets.py errors after we touched the shebangs
+  touch Include/Python-ast.h Python/Python-ast.c Python/opcode_targets.h
+
+  # FS#48761
+  # http://bugs.python.org/issue25750
+  patch -p1 -i ../descr_ref.patch
+}
+
+build() {
+  cd "${srcdir}/Python-${pkgver}"
+
+  export OPT="${CFLAGS}"
+  ./configure --prefix=/usr \
+              --enable-shared \
+              --with-threads \
+              --enable-ipv6 \
+              --enable-unicode=ucs4 \
+              --with-system-expat \
+              --with-system-ffi \
+              --with-dbmliborder=gdbm:ndbm \
+              --without-ensurepip
+
+  make
+}
+
+check() {
+  # As of 2.7.11, 2 tests failed:
+  # test_doctest test_gdb
+  # Besides, test_thread disabled as it will stuck
+  
+  # $SHELL was set to avoid a test failure in test_gdb (it still fails due to other reasons, though)
+
+  cd Python-${pkgver}
+  SHELL=/bin/sh LD_LIBRARY_PATH="${srcdir}/Python-${pkgver}":${LD_LIBRARY_PATH} \
+    "${srcdir}/Python-${pkgver}/python" -m test.regrtest -v -uall -x test_thread || warning "Tests failed"
+}
+
+package() {
+  cd Python-${pkgver}
+  make DESTDIR="${pkgdir}" altinstall maninstall
+
+  rm "${pkgdir}"/usr/share/man/man1/python.1
+
+  ln -sf python${_pybasever}        "${pkgdir}"/usr/bin/python2
+  ln -sf python${_pybasever}-config "${pkgdir}"/usr/bin/python2-config
+  ln -sf python${_pybasever}.1      "${pkgdir}"/usr/share/man/man1/python2.1
+
+  # FS#33954
+  ln -sf python-${_pybasever}.pc    "${pkgdir}"/usr/lib/pkgconfig/python2.pc
+
+  ln -sf ../../libpython${_pybasever}.so "${pkgdir}"/usr/lib/python${_pybasever}/config/libpython${_pybasever}.so
+
+  mv "${pkgdir}"/usr/bin/smtpd.py "${pkgdir}"/usr/lib/python${_pybasever}/
+
+  # some useful "stuff"
+  install -dm755 "${pkgdir}"/usr/lib/python${_pybasever}/Tools/{i18n,scripts}
+  install -m755 Tools/i18n/{msgfmt,pygettext}.py "${pkgdir}"/usr/lib/python${_pybasever}/Tools/i18n/
+  install -m755 Tools/scripts/{README,*py} "${pkgdir}"/usr/lib/python${_pybasever}/Tools/scripts/
+
+  # fix conflicts with python
+  mv "${pkgdir}"/usr/bin/idle{,2}
+  mv "${pkgdir}"/usr/bin/pydoc{,2}
+  mv "${pkgdir}"/usr/bin/2to3{,-2.7}
+
+  # clean-up reference to build directory
+  sed -i "s#${srcdir}/Python-${pkgver}:##" "${pkgdir}"/usr/lib/python${_pybasever}/config/Makefile
+
+  # license
+  install -Dm644 LICENSE "${pkgdir}"/usr/share/licenses/${pkgname}/LICENSE
+}

Copied: python2/repos/extra-i686/descr_ref.patch (from rev 263481, python2/trunk/descr_ref.patch)
===================================================================
--- extra-i686/descr_ref.patch	                        (rev 0)
+++ extra-i686/descr_ref.patch	2016-03-31 06:43:46 UTC (rev 263482)
@@ -0,0 +1,58 @@
+When calling tp_descr_get(self, obj, type), make sure that we own a reference to "self"
+
+diff -ru Python-2.7.9/Objects/typeobject.c Python-2.7.9-fixed//Objects/typeobject.c
+--- Python-2.7.9/Objects/typeobject.c	2014-12-10 16:59:57.000000000 +0100
++++ Python-2.7.9-fixed//Objects/typeobject.c	2015-11-27 20:39:58.276156800 +0100
+@@ -2542,6 +2542,7 @@
+     PyTypeObject *metatype = Py_TYPE(type);
+     PyObject *meta_attribute, *attribute;
+     descrgetfunc meta_get;
++    PyObject* res;
+ 
+     if (!PyString_Check(name)) {
+         PyErr_Format(PyExc_TypeError,
+@@ -2563,6 +2564,7 @@
+     meta_attribute = _PyType_Lookup(metatype, name);
+ 
+     if (meta_attribute != NULL) {
++        Py_INCREF(meta_attribute);
+         meta_get = Py_TYPE(meta_attribute)->tp_descr_get;
+ 
+         if (meta_get != NULL && PyDescr_IsData(meta_attribute)) {
+@@ -2570,10 +2572,11 @@
+              * writes. Assume the attribute is not overridden in
+              * type's tp_dict (and bases): call the descriptor now.
+              */
+-            return meta_get(meta_attribute, (PyObject *)type,
++            res = meta_get(meta_attribute, (PyObject *)type,
+                             (PyObject *)metatype);
++            Py_DECREF(meta_attribute);
++            return res;
+         }
+-        Py_INCREF(meta_attribute);
+     }
+ 
+     /* No data descriptor found on metatype. Look in tp_dict of this
+@@ -2581,6 +2584,7 @@
+     attribute = _PyType_Lookup(type, name);
+     if (attribute != NULL) {
+         /* Implement descriptor functionality, if any */
++        Py_INCREF(attribute);
+         descrgetfunc local_get = Py_TYPE(attribute)->tp_descr_get;
+ 
+         Py_XDECREF(meta_attribute);
+@@ -2588,11 +2592,12 @@
+         if (local_get != NULL) {
+             /* NULL 2nd argument indicates the descriptor was
+              * found on the target object itself (or a base)  */
+-            return local_get(attribute, (PyObject *)NULL,
++            res = local_get(attribute, (PyObject *)NULL,
+                              (PyObject *)type);
++            Py_DECREF(attribute);
++            return res;
+         }
+ 
+-        Py_INCREF(attribute);
+         return attribute;
+     }
+ 

Deleted: extra-x86_64/PKGBUILD
===================================================================
--- extra-x86_64/PKGBUILD	2016-03-31 06:43:03 UTC (rev 263481)
+++ extra-x86_64/PKGBUILD	2016-03-31 06:43:46 UTC (rev 263482)
@@ -1,121 +0,0 @@
-# $Id$
-# Maintainer: Felix Yan <felixonmars at archlinux.org>
-# Contributor: Stéphane Gaudreault <stephane at archlinux.org>
-# Contributor: Allan McRae <allan at archlinux.org>
-# Contributor: Jason Chu <jason at archlinux.org>
-
-pkgname=python2
-pkgver=2.7.11
-pkgrel=2
-_pybasever=2.7
-pkgdesc="A high-level scripting language"
-arch=('i686' 'x86_64')
-license=('PSF')
-url="http://www.python.org/"
-depends=('bzip2' 'gdbm' 'openssl' 'zlib' 'expat' 'sqlite' 'libffi')
-makedepends=('tk' 'bluez-libs' 'hardening-wrapper')
-checkdepends=('gdb' 'file')
-optdepends=('tk: for IDLE'
-            'python2-setuptools'
-            'python2-pip')
-conflicts=('python<3')
-source=(http://www.python.org/ftp/python/${pkgver%rc?}/Python-${pkgver}.tar.xz)
-sha1sums=('c3b8bbe3f084c4d4ea13ffb03d75a5e22f9756ff')
-
-prepare() {
-  cd Python-${pkgver}
-
-  # Temporary workaround for FS#22322
-  # See http://bugs.python.org/issue10835 for upstream report
-  sed -i "/progname =/s/python/python${_pybasever}/" Python/pythonrun.c
-
-  # Enable built-in SQLite module to load extensions (fix FS#22122)
-  sed -i "/SQLITE_OMIT_LOAD_EXTENSION/d" setup.py
-
-  # FS#23997
-  sed -i -e "s|^#.* /usr/local/bin/python|#!/usr/bin/python2|" Lib/cgi.py
-
-  sed -i "s/python2.3/python2/g" Lib/distutils/tests/test_build_scripts.py \
-    Lib/distutils/tests/test_install_scripts.py
-
-  # TODO: Still not passed
-  # Silent test_gdb failures on 'no symbol table loaded'.
-  #sed -i '/ignore_patterns = (/a "No symbol table is loaded.  Use the \\"file\\" command.",' \
-  #  Lib/test/test_gdb.py
-
-  # Ensure that we are using the system copy of various libraries (expat, zlib and libffi),
-  # rather than copies shipped in the tarball
-  rm -r Modules/expat
-  rm -r Modules/zlib
-  rm -r Modules/_ctypes/{darwin,libffi}*
-
-  # clean up #!s
-  find . -name '*.py' | \
-    xargs sed -i "s|#[ ]*![ ]*/usr/bin/env python$|#!/usr/bin/env python2|"
-
-  # Workaround asdl_c.py/makeopcodetargets.py errors after we touched the shebangs
-  touch Include/Python-ast.h Python/Python-ast.c Python/opcode_targets.h
-}
-
-build() {
-  cd "${srcdir}/Python-${pkgver}"
-
-  export OPT="${CFLAGS}"
-  ./configure --prefix=/usr \
-              --enable-shared \
-              --with-threads \
-              --enable-ipv6 \
-              --enable-unicode=ucs4 \
-              --with-system-expat \
-              --with-system-ffi \
-              --with-dbmliborder=gdbm:ndbm \
-              --without-ensurepip
-
-  make
-}
-
-check() {
-  # As of 2.7.11, 2 tests failed:
-  # test_doctest test_gdb
-  # Besides, test_thread disabled as it will stuck
-  
-  # $SHELL was set to avoid a test failure in test_gdb (it still fails due to other reasons, though)
-
-  cd Python-${pkgver}
-  SHELL=/bin/sh LD_LIBRARY_PATH="${srcdir}/Python-${pkgver}":${LD_LIBRARY_PATH} \
-    "${srcdir}/Python-${pkgver}/python" -m test.regrtest -v -uall -x test_thread || warning "Tests failed"
-}
-
-package() {
-  cd Python-${pkgver}
-  make DESTDIR="${pkgdir}" altinstall maninstall
-
-  rm "${pkgdir}"/usr/share/man/man1/python.1
-
-  ln -sf python${_pybasever}        "${pkgdir}"/usr/bin/python2
-  ln -sf python${_pybasever}-config "${pkgdir}"/usr/bin/python2-config
-  ln -sf python${_pybasever}.1      "${pkgdir}"/usr/share/man/man1/python2.1
-
-  # FS#33954
-  ln -sf python-${_pybasever}.pc    "${pkgdir}"/usr/lib/pkgconfig/python2.pc
-
-  ln -sf ../../libpython${_pybasever}.so "${pkgdir}"/usr/lib/python${_pybasever}/config/libpython${_pybasever}.so
-
-  mv "${pkgdir}"/usr/bin/smtpd.py "${pkgdir}"/usr/lib/python${_pybasever}/
-
-  # some useful "stuff"
-  install -dm755 "${pkgdir}"/usr/lib/python${_pybasever}/Tools/{i18n,scripts}
-  install -m755 Tools/i18n/{msgfmt,pygettext}.py "${pkgdir}"/usr/lib/python${_pybasever}/Tools/i18n/
-  install -m755 Tools/scripts/{README,*py} "${pkgdir}"/usr/lib/python${_pybasever}/Tools/scripts/
-
-  # fix conflicts with python
-  mv "${pkgdir}"/usr/bin/idle{,2}
-  mv "${pkgdir}"/usr/bin/pydoc{,2}
-  mv "${pkgdir}"/usr/bin/2to3{,-2.7}
-
-  # clean-up reference to build directory
-  sed -i "s#${srcdir}/Python-${pkgver}:##" "${pkgdir}"/usr/lib/python${_pybasever}/config/Makefile
-
-  # license
-  install -Dm644 LICENSE "${pkgdir}"/usr/share/licenses/${pkgname}/LICENSE
-}

Copied: python2/repos/extra-x86_64/PKGBUILD (from rev 263481, python2/trunk/PKGBUILD)
===================================================================
--- extra-x86_64/PKGBUILD	                        (rev 0)
+++ extra-x86_64/PKGBUILD	2016-03-31 06:43:46 UTC (rev 263482)
@@ -0,0 +1,127 @@
+# $Id$
+# Maintainer: Felix Yan <felixonmars at archlinux.org>
+# Contributor: Stéphane Gaudreault <stephane at archlinux.org>
+# Contributor: Allan McRae <allan at archlinux.org>
+# Contributor: Jason Chu <jason at archlinux.org>
+
+pkgname=python2
+pkgver=2.7.11
+pkgrel=3
+_pybasever=2.7
+pkgdesc="A high-level scripting language"
+arch=('i686' 'x86_64')
+license=('PSF')
+url="http://www.python.org/"
+depends=('bzip2' 'gdbm' 'openssl' 'zlib' 'expat' 'sqlite' 'libffi')
+makedepends=('tk' 'bluez-libs' 'hardening-wrapper')
+checkdepends=('gdb' 'file')
+optdepends=('tk: for IDLE'
+            'python2-setuptools'
+            'python2-pip')
+conflicts=('python<3')
+source=(http://www.python.org/ftp/python/${pkgver%rc?}/Python-${pkgver}.tar.xz
+        descr_ref.patch)
+sha1sums=('c3b8bbe3f084c4d4ea13ffb03d75a5e22f9756ff'
+          '8cc6ac63e909063eb16bbdabc0f0eac7d24ff0c1')
+
+prepare() {
+  cd Python-${pkgver}
+
+  # Temporary workaround for FS#22322
+  # See http://bugs.python.org/issue10835 for upstream report
+  sed -i "/progname =/s/python/python${_pybasever}/" Python/pythonrun.c
+
+  # Enable built-in SQLite module to load extensions (fix FS#22122)
+  sed -i "/SQLITE_OMIT_LOAD_EXTENSION/d" setup.py
+
+  # FS#23997
+  sed -i -e "s|^#.* /usr/local/bin/python|#!/usr/bin/python2|" Lib/cgi.py
+
+  sed -i "s/python2.3/python2/g" Lib/distutils/tests/test_build_scripts.py \
+    Lib/distutils/tests/test_install_scripts.py
+
+  # TODO: Still not passed
+  # Silent test_gdb failures on 'no symbol table loaded'.
+  #sed -i '/ignore_patterns = (/a "No symbol table is loaded.  Use the \\"file\\" command.",' \
+  #  Lib/test/test_gdb.py
+
+  # Ensure that we are using the system copy of various libraries (expat, zlib and libffi),
+  # rather than copies shipped in the tarball
+  rm -r Modules/expat
+  rm -r Modules/zlib
+  rm -r Modules/_ctypes/{darwin,libffi}*
+
+  # clean up #!s
+  find . -name '*.py' | \
+    xargs sed -i "s|#[ ]*![ ]*/usr/bin/env python$|#!/usr/bin/env python2|"
+
+  # Workaround asdl_c.py/makeopcodetargets.py errors after we touched the shebangs
+  touch Include/Python-ast.h Python/Python-ast.c Python/opcode_targets.h
+
+  # FS#48761
+  # http://bugs.python.org/issue25750
+  patch -p1 -i ../descr_ref.patch
+}
+
+build() {
+  cd "${srcdir}/Python-${pkgver}"
+
+  export OPT="${CFLAGS}"
+  ./configure --prefix=/usr \
+              --enable-shared \
+              --with-threads \
+              --enable-ipv6 \
+              --enable-unicode=ucs4 \
+              --with-system-expat \
+              --with-system-ffi \
+              --with-dbmliborder=gdbm:ndbm \
+              --without-ensurepip
+
+  make
+}
+
+check() {
+  # As of 2.7.11, 2 tests failed:
+  # test_doctest test_gdb
+  # Besides, test_thread disabled as it will stuck
+  
+  # $SHELL was set to avoid a test failure in test_gdb (it still fails due to other reasons, though)
+
+  cd Python-${pkgver}
+  SHELL=/bin/sh LD_LIBRARY_PATH="${srcdir}/Python-${pkgver}":${LD_LIBRARY_PATH} \
+    "${srcdir}/Python-${pkgver}/python" -m test.regrtest -v -uall -x test_thread || warning "Tests failed"
+}
+
+package() {
+  cd Python-${pkgver}
+  make DESTDIR="${pkgdir}" altinstall maninstall
+
+  rm "${pkgdir}"/usr/share/man/man1/python.1
+
+  ln -sf python${_pybasever}        "${pkgdir}"/usr/bin/python2
+  ln -sf python${_pybasever}-config "${pkgdir}"/usr/bin/python2-config
+  ln -sf python${_pybasever}.1      "${pkgdir}"/usr/share/man/man1/python2.1
+
+  # FS#33954
+  ln -sf python-${_pybasever}.pc    "${pkgdir}"/usr/lib/pkgconfig/python2.pc
+
+  ln -sf ../../libpython${_pybasever}.so "${pkgdir}"/usr/lib/python${_pybasever}/config/libpython${_pybasever}.so
+
+  mv "${pkgdir}"/usr/bin/smtpd.py "${pkgdir}"/usr/lib/python${_pybasever}/
+
+  # some useful "stuff"
+  install -dm755 "${pkgdir}"/usr/lib/python${_pybasever}/Tools/{i18n,scripts}
+  install -m755 Tools/i18n/{msgfmt,pygettext}.py "${pkgdir}"/usr/lib/python${_pybasever}/Tools/i18n/
+  install -m755 Tools/scripts/{README,*py} "${pkgdir}"/usr/lib/python${_pybasever}/Tools/scripts/
+
+  # fix conflicts with python
+  mv "${pkgdir}"/usr/bin/idle{,2}
+  mv "${pkgdir}"/usr/bin/pydoc{,2}
+  mv "${pkgdir}"/usr/bin/2to3{,-2.7}
+
+  # clean-up reference to build directory
+  sed -i "s#${srcdir}/Python-${pkgver}:##" "${pkgdir}"/usr/lib/python${_pybasever}/config/Makefile
+
+  # license
+  install -Dm644 LICENSE "${pkgdir}"/usr/share/licenses/${pkgname}/LICENSE
+}

Copied: python2/repos/extra-x86_64/descr_ref.patch (from rev 263481, python2/trunk/descr_ref.patch)
===================================================================
--- extra-x86_64/descr_ref.patch	                        (rev 0)
+++ extra-x86_64/descr_ref.patch	2016-03-31 06:43:46 UTC (rev 263482)
@@ -0,0 +1,58 @@
+When calling tp_descr_get(self, obj, type), make sure that we own a reference to "self"
+
+diff -ru Python-2.7.9/Objects/typeobject.c Python-2.7.9-fixed//Objects/typeobject.c
+--- Python-2.7.9/Objects/typeobject.c	2014-12-10 16:59:57.000000000 +0100
++++ Python-2.7.9-fixed//Objects/typeobject.c	2015-11-27 20:39:58.276156800 +0100
+@@ -2542,6 +2542,7 @@
+     PyTypeObject *metatype = Py_TYPE(type);
+     PyObject *meta_attribute, *attribute;
+     descrgetfunc meta_get;
++    PyObject* res;
+ 
+     if (!PyString_Check(name)) {
+         PyErr_Format(PyExc_TypeError,
+@@ -2563,6 +2564,7 @@
+     meta_attribute = _PyType_Lookup(metatype, name);
+ 
+     if (meta_attribute != NULL) {
++        Py_INCREF(meta_attribute);
+         meta_get = Py_TYPE(meta_attribute)->tp_descr_get;
+ 
+         if (meta_get != NULL && PyDescr_IsData(meta_attribute)) {
+@@ -2570,10 +2572,11 @@
+              * writes. Assume the attribute is not overridden in
+              * type's tp_dict (and bases): call the descriptor now.
+              */
+-            return meta_get(meta_attribute, (PyObject *)type,
++            res = meta_get(meta_attribute, (PyObject *)type,
+                             (PyObject *)metatype);
++            Py_DECREF(meta_attribute);
++            return res;
+         }
+-        Py_INCREF(meta_attribute);
+     }
+ 
+     /* No data descriptor found on metatype. Look in tp_dict of this
+@@ -2581,6 +2584,7 @@
+     attribute = _PyType_Lookup(type, name);
+     if (attribute != NULL) {
+         /* Implement descriptor functionality, if any */
++        Py_INCREF(attribute);
+         descrgetfunc local_get = Py_TYPE(attribute)->tp_descr_get;
+ 
+         Py_XDECREF(meta_attribute);
+@@ -2588,11 +2592,12 @@
+         if (local_get != NULL) {
+             /* NULL 2nd argument indicates the descriptor was
+              * found on the target object itself (or a base)  */
+-            return local_get(attribute, (PyObject *)NULL,
++            res = local_get(attribute, (PyObject *)NULL,
+                              (PyObject *)type);
++            Py_DECREF(attribute);
++            return res;
+         }
+ 
+-        Py_INCREF(attribute);
+         return attribute;
+     }
+ 



More information about the arch-commits mailing list